import { _decorator, Component, Node } from "cc";
import { Notifications } from "../easyFramework/notifications";
import { LocalCache } from "../utils/LocalCache";

const { ccclass, property } = _decorator;

//基础数据结构
class BaseData {
    protected dictCache: any
    protected cacheName
    constructor(cacheName: any) {
        this.cacheName = cacheName;
    }
    //重新开始
    resetCache() {

    }
    //复活
    reAlive() {

    }
    /**
      * 添加事件
      * @param {string} eKey     识别key
      * @param {object} eCall    回调函数
      * @param {object} self     识别对象
      */
    protected on(eKey: string, eCall: any, self?: Object) {
        Notifications.on(eKey, eCall, self ? self : this);
    }
    /**
     * 通知事件
     * @param {string} eKey     识别key
     * @param {object} data     传值
     * @param {object} data2     传值
     */
    protected emit(eKey: string, ...parameters: any[]) {
        let a = Notifications.emit(eKey, ...parameters);
        if (a) {
            return a;
        }
    }

    /**
    * 注销某个事件
    * @param {string} eKey 识别key
    * @param {object} self 识别对象 
    */
    protected off(eKey: string, self?: Object) {
        Notifications.off(eKey, self ? self : this);
    }

    protected getCache() {
        return LocalCache.getItem(this.cacheName);
    }
    /**保存数据到缓存 */
    protected updateCache() {
        LocalCache.setItem(this.cacheName, this.dictCache);
    }
    //根据id从数组中获取需要的配置
    protected getListCfgById(cfg: any, id: number) {
        for (let i = 0; i < cfg.length; i++) {
            if (cfg[i].ID == id) return cfg[i];
        }
        return null;
    }
}

export default BaseData;