import { SystemEventType, Game, game, JsonAsset } from "cc";
import playerMgr from "./playMgr";
import levelMgr from "./levelMgr";
import { Notifications } from "../easyFramework/notifications";
import GDef from "./GDef";

//游戏世界数据层
class GD {
    playerMgr: playerMgr//玩家信息管理
    levelMgr: levelMgr //关卡数据
    constructor() {
        this.playerMgr = new playerMgr;
        this.levelMgr = new levelMgr;
    }



    // private cutFun = null;
    init() {
        this.playerMgr.init();//初始化玩家管理
        this.levelMgr.init();//初始化关卡管理
        //监听切换后台
        game.on(Game.EVENT_HIDE, () => {
            game.pause();//暂停游戏
        });
        game.on(Game.EVENT_SHOW, () => {
            game.resume();//恢复游戏
            setTimeout(() => {
                Notifications.emit(GDef.wdEvent.playBgm, true);
            }, 500);
        });

    }

}

export default new GD;
