import { _decorator, Component, Node, LabelComponent, SpriteComponent, SpriteFrame, Sprite, tween, v3 } from 'cc';
import { tyqSDK } from './tyq-sdk';
const { ccclass, property } = _decorator;

@ccclass('tyq_boxItem')
export class tyq_boxItem extends Component {

    @property({
        type: SpriteFrame,
        tooltip: "宝箱打开的图片"
    })
    openSp: SpriteFrame = null!;

    @property({
        type: Sprite,
        tooltip: "要替换图片的节点"
    })
    baoxiang: Sprite = null!;

    @property({
        type: Node,
        tooltip: "背景光"
    })
    guang: Node = null!;

    @property({
        type: Node,
        tooltip: "奖励"
    })
    reward: Node = null!;

    @property({
        type: SpriteFrame,
        tooltip: "体力和钻石的图片"
    })
    spList: SpriteFrame[] = [];

    /**是否是视频宝箱 */
    public isWatch: boolean = false;

    /**
     * 
     * @param type 是否是视频宝箱
     */
    init(type: boolean) {
        this.isWatch = type;
        if (!this.isWatch) {
            this.node.getChildByName("video")!.active = false;
        }
        // if (!taolu) {
        //     this.node.getChildByName("video")!.getComponent(SpriteComponent)!.color._set_a_unsafe(255);
        // }
    }

    /**获取是否是视频宝箱 */
    get watch() {
        return this.isWatch;
    }

    /**打开宝箱 */
    open() {
        this.baoxiang.spriteFrame = this.openSp;
        this.node.getChildByName("video")!.active = false;
        this.guang.active = true;
        tween(this.guang).by(2, { eulerAngles: v3(0, 0, 360) }).repeatForever().start();
        const num = tyqSDK.RandomNumBoth(0, 1);
        this.reward.active = true;
        this.reward.getComponent(Sprite)!.spriteFrame = this.spList[num];
        if (num == 0) {
            tyqSDK.Physical = 1;
        } else {
            tyqSDK.Diamonds = 1;
        }
        //奖励逻辑请写在这里
    }

    /**变成普通宝箱 */
    changeType() {
        this.isWatch = false;
        this.node.getChildByName("video")!.active = false;
    }
    // update (deltaTime: number) {
    //     // Your update function goes here.
    // }
}
