import { _decorator, Component, Node, Tween, tween, v3, ProgressBarComponent } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { tyqSDK } from './tyq-sdk';
const { ccclass, property } = _decorator;

@ccclass('tyq_crazyBox')
export class tyq_crazyBox extends Component {
    @property({
        type: Node,
        tooltip: "宝箱icon，用来做动画"
    })
    box: Node = null!;

    @property({
        type: ProgressBarComponent,
        tooltip: "进度条"
    })
    progress: ProgressBarComponent = null!;

    @property({
        type: Node,
        tooltip: "蛋壳上半部分"
    })
    Eggshell: Node = null!;

    @property({
        type: Node,
        tooltip: "钻石"
    })
    diamonds: Node = null!;

    private twn = new Tween();
    private addNum = 0.1;
    private cutNum = 0.005;
    private openAD = 3;
    private canTouch = true;
    private callBack: Function | null = null;
    private schFun: boolean = false;
    start() {
        // Your initialization goes here.
    }

    inint(callBack: Function) {
        this.node.active = true
        this.callBack = callBack;
        this.canTouch = true;
        this.progress.progress = 0;
        const arry = tyqSDK.getSwitchValue("crazyEggOperCtr");//狂点彩蛋控制
        if (arry) {
            const openList = arry.split(",");
            if (openList.length > 2) {
                this.addNum = Number(openList[0]);//一次的进度
                this.cutNum = Number(openList[1]);//一次倒退的进度
                this.openAD = Number(openList[2]);//多久后打开视频广告
            }
        }
    }

    openBtnFun() {
        if (!this.canTouch) return;
        if (!this.schFun) {
            this.schFun = true;
            this.scheduleOnce(() => {
                this.nextFun();
            }, this.openAD)
        }
        this.twn.stop();
        this.twn = tween(this.box)
            .to(0.05, { eulerAngles: v3(0, 0, 10) })
            .to(0.1, { eulerAngles: v3(0, 0, -10) })
            .to(0.05, { eulerAngles: v3(0, 0, 0) })
            .union()
            .start()
        this.progress.progress += this.addNum;
        //0.25表示进度百分比
        // if (this.progress.progress > this.openAD && this.canTouch) {
        //     this.nextFun();
        // }
    }
    nextFun() {
        this.canTouch = false;
        tyqSDK.showVideoAD("狂点彩蛋", () => {
            //打开彩蛋
            tween(this.Eggshell)
                .by(1, { eulerAngles: v3(0, 0, -60) })
                .call(() => {
                    this.diamonds.active = true;
                })
                .delay(1)
                .call(() => {
                    tween(this.diamonds).to(1.5, { scale: v3(0.4, 0.4), position: v3(-200, 450) })
                        .call(() => {
                            tyqSDK.Diamonds = 2;
                            if (this.callBack) {
                                this.callBack();
                            }
                            this.node.destroy();
                        })
                        .start();
                })
                .start();

        }, () => {
            if (this.callBack) {
                this.callBack();
            }
            this.node.destroy();
        })
    }

    update(deltaTime: number) {
        if (this.progress.progress > 0) {
            this.progress.progress -= this.cutNum;
        }
    }

}
