import { _decorator, Component, Node, loader, ImageAsset, SpriteFrame, Texture2D, SpriteComponent, resources, assetManager } from 'cc';
import { gameInfo, tyqSDK } from './tyq-sdk';
const { ccclass, property } = _decorator;

@ccclass('TyqIbanner')
export class TyqIbanner extends Component {

    start() {
        if (tyqSDK.gameBannerList.length == 0) return;
        const gameValeu: gameInfo = tyqSDK.gameBannerList[0];
        assetManager.loadRemote(gameValeu.gameImg, (err: any, spf: ImageAsset) => {
            if (err) {
                console.log(err);
                return;
            };
            const sp = new SpriteFrame();
            const tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            this.node.getComponent(SpriteComponent)!.spriteFrame = sp;
        })
        this.node.on(Node.EventType.TOUCH_END, () => {
            tyqSDK.navigateToVideoView(gameValeu, "banner");
        }, this)
        // Your initialization goes here.
    }

    // update (deltaTime: number) {
    //     // Your update function goes here.
    // }
}
