import { _decorator, Component, Node, ButtonComponent, Label, Prefab, game } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { Toutiao } from './tyqToutiao';
import { tyqSDK } from './tyq-sdk';
import tyqSDKConfig from './tyq-sdk-config';
const { ccclass, property } = _decorator;

@ccclass('tyq_main')
export class tyq_main extends SDKbaseView {

    @property({
        type: Node,
        tooltip: "体力"
    })
    physical: Node = null!;
    @property({
        type: Node,
        tooltip: "钻石"
    })
    diamonds: Node = null!;
    @property({
        type: Node,
        tooltip: "更多游戏"
    })
    moreGame: Node = null!;
    @property({
        type: Node,
        tooltip: "幸运抽奖"
    })
    luckDraw: Node = null!;
    @property({
        type: Node,
        tooltip: "关注"
    })
    follow: Node = null!;
    @property({
        type: Node,
        tooltip: "内测福利"
    })
    welfare: Node = null!;

    @property({
        type: Prefab,
        tooltip: "vip面板"
    })
    tyq_vipPanel: Prefab = null!;

    private static _instance: tyq_main = null!;

    static getInstance() {
        if (!this._instance) {
            console.error("场景未初始化");
        } else {
            return this._instance
        }
    }

    start() {
        tyq_main._instance = this;
        // //根据开关判断是否需要打开这些功能
        this.showMain();

        const phyAdd = this.physical.getChildByName("add")!
        const dimAdd = this.diamonds.getChildByName("add")!
        dimAdd.active = tyqSDK.getSwitchInfoByName("addPlus");
        phyAdd.active = tyqSDK.getSwitchInfoByName("addPlus");

        //绑定按钮
        this.bindButton(this.moreGame, () => {//更多游戏
            tyqSDK.showMoreGameBoxPanel(true);
        });
        this.bindButton(this.follow, () => {//关注
            Toutiao.openAwemeUserProfile();
        });
        this.bindButton(this.luckDraw, () => {//幸运抽奖
            tyqSDK.showLuckDraw();
        });
        this.bindButton(this.welfare, () => {//内测
            this.showUI(this.tyq_vipPanel, this.node.parent!);
        })

        this.bindButton(phyAdd, () => {//体力
            tyqSDK.showVideoAD("主页体力加号", () => {
                tyqSDK.Physical = 1;
            })
        });
        this.bindButton(dimAdd, () => {//钻石
            tyqSDK.showVideoAD("主页钻石加号", () => {
                tyqSDK.Diamonds = 1;
            })
        })
        


        //开启增加体力倒计时
        this.upDataString();
        this.countDown();
    }

    /**倒计时 */
    countDown() {
        const phy = tyqSDK.Physical;
        if (phy < 10) {
            var timer = 60 * tyqSDKConfig.recoverTime
            this.physical.getChildByName("countDown")!.active = true;
            this.scheduleOnce(() => {
                tyqSDK.Physical = 1;
                this.upDataString();
                this.countDown();
            }, 60 * tyqSDKConfig.recoverTime);
            this.schedule(() => {
                timer--;
                let min = Math.floor(timer / 60)//获取分钟，除以60取整数，得到整数分钟
                let secondTime = timer % 60//获取秒数，秒数取佘，得到整数秒数
                this.physical.getChildByName("countDown")!.getComponent(Label)!.string = min.toString().padStart(2, '0') + ":" + secondTime.toString().padStart(2, '0');
            }, 1, 60 * tyqSDKConfig.recoverTime)
        } else {
            this.physical.getChildByName("countDown")!.active = false;
        }
    }

    /**改变体力 */
    changePhy() {
        const phy = tyqSDK.Physical;
        if (phy > 10) {
            this.unscheduleAllCallbacks();
            this.physical.getChildByName("countDown")!.active = false;
        }
        this.upDataString();
    }

    upDataString() {
        this.physical.getChildByName("Label")!.getComponent(Label)!.string = tyqSDK.Physical + "";
        this.diamonds.getChildByName("Label")!.getComponent(Label)!.string = tyqSDK.Diamonds + ""
    }

    hideMain(){
        this.moreGame.active = false;
        this.luckDraw.active = false;
        this.follow.active = false;
        this.welfare.active = false;
    }

    showMain(){
        this.moreGame.active = tyqSDK.getSwitchInfoByName("moreGame");
        this.luckDraw.active = tyqSDK.getSwitchByName("luckDraw");
        this.follow.active = tyqSDK.getSwitchByName("follow");
        this.welfare.active = tyqSDK.getSwitchByName("welfare");
    }
    // onDestroy(){
    //     console.log("被销毁");
    // }
    // onDisable(){
    //     console.log("被隐藏");
    // }
}