
import { _decorator, Component, Node, Label } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { tyqSDK } from './tyq-sdk';
import tyqSDKConfig from './tyq-sdk-config';
const { ccclass, property } = _decorator;

@ccclass('TyqVipPanel')
export class TyqVipPanel extends SDKbaseView {
    @property({
        type: Node,
        tooltip: "关闭"
    })
    close: Node = null!;
    @property({
        type: Node,
        tooltip: "看视频"
    })
    video: Node = null!;
    @property({
        type: Node,
        tooltip: "已领取"
    })
    yilinqu: Node = null!;

    @property({
        type: Label,
        tooltip: "进度文字"
    })
    label: Label = null!;
    start() {
        this.init();
        this.bindButton(this.close, () => {
            this.node.destroy();
        });
        this.bindButton(this.video, () => {
            tyqSDK.showVideoAD("vip", () => {
                const vipinfo = tyqSDK.getItem("tyq_vip");
                let num = Number(vipinfo.count);
                num++;
                vipinfo.count = num;
                tyqSDK.setItem("tyq_vip", vipinfo);
                this.init();
            })
        })
        this.bindButton(this.yilinqu, () => {
            this.node.destroy();
        })
    }
    init() {
        const vipinfo = tyqSDK.getItem("tyq_vip");
        if (vipinfo.count >= tyqSDKConfig.vipCount) {
            this.video.active = false;
            this.yilinqu.active = true;
            tyqSDK.Vip = true;
        } else {
            this.video.active = true;
            this.yilinqu.active = false;
            this.label.string = vipinfo.count + "/" + tyqSDKConfig.vipCount;
        }
    }
}

