
import { _decorator, Component, Node, director } from 'cc';
import BaseView from './Script/miniGamefram/game/BaseView';
const { ccclass, property } = _decorator;

@ccclass('Test')
export class Test extends BaseView {
    @property({
        type: Node,
        tooltip: "首次进入游戏"
    })
    inGame: Node = null!;
    @property({
        type: Node,
        tooltip: "主页"
    })
    mainGame: Node = null!;
    @property({
        type: Node,
        tooltip: "开始游戏"
    })
    startGame: Node = null!;
    @property({
        type: Node,
        tooltip: "结束游戏"
    })
    endGame: Node = null!;
    @property({
        type: Node,
        tooltip: "切换场景"
    })
    loadScenen: Node = null!;
    start() {
        TyqSdk.init(() => {
            this.bindButton(this.inGame, () => {//进入游戏场景
                TyqSdk.inGameScene(this.node);
            })
            this.bindButton(this.mainGame, () => {
                TyqSdk.showMain();
            })
            this.bindButton(this.startGame, () => {
                TyqSdk.startGame(1,()=>{
                    this.startGameFun();
                })
            })
            this.bindButton(this.endGame, () => {
                TyqSdk.endGame("lose",()=>{
                    this.endGameFun();
                })
            })

            this.bindButton(this.loadScenen,()=>{
                director.loadScene("scene");
            })
        });
        // [3]

    }


    startGameFun(){
        console.log("游戏正式开始");
    }

    endGameFun(){
        console.log("游戏结束");
    }
    // update (deltaTime: number) {
    //     // [4]
    // }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
