System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../easyFramework/notifications", "../utils/LocalCache"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Notifications, LocalCache, BaseData, _crd, ccclass, property;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../easyFramework/notifications", _context.meta, extras);
  }

  function _reportPossibleCrUseOfLocalCache(extras) {
    _reporterNs.report("LocalCache", "../utils/LocalCache", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
    }, function (_easyFrameworkNotifications) {
      Notifications = _easyFrameworkNotifications.Notifications;
    }, function (_utilsLocalCache) {
      LocalCache = _utilsLocalCache.LocalCache;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "2dc60QPZHFJD5GnCQ4TtHQa", "BaseData", undefined);

      ({
        ccclass,
        property
      } = _decorator); //基础数据结构

      BaseData = class BaseData {
        constructor(cacheName) {
          _defineProperty(this, "dictCache", void 0);

          _defineProperty(this, "cacheName", void 0);

          this.cacheName = cacheName;
        } //重新开始


        resetCache() {} //复活


        reAlive() {}
        /**
          * 添加事件
          * @param {string} eKey     识别key
          * @param {object} eCall    回调函数
          * @param {object} self     识别对象
          */


        on(eKey, eCall, self) {
          (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).on(eKey, eCall, self ? self : this);
        }
        /**
         * 通知事件
         * @param {string} eKey     识别key
         * @param {object} data     传值
         * @param {object} data2     传值
         */


        emit(eKey, ...parameters) {
          let a = (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).emit(eKey, ...parameters);

          if (a) {
            return a;
          }
        }
        /**
        * 注销某个事件
        * @param {string} eKey 识别key
        * @param {object} self 识别对象 
        */


        off(eKey, self) {
          (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).off(eKey, self ? self : this);
        }

        getCache() {
          return (_crd && LocalCache === void 0 ? (_reportPossibleCrUseOfLocalCache({
            error: Error()
          }), LocalCache) : LocalCache).getItem(this.cacheName);
        }
        /**保存数据到缓存 */


        updateCache() {
          (_crd && LocalCache === void 0 ? (_reportPossibleCrUseOfLocalCache({
            error: Error()
          }), LocalCache) : LocalCache).setItem(this.cacheName, this.dictCache);
        } //根据id从数组中获取需要的配置


        getListCfgById(cfg, id) {
          for (let i = 0; i < cfg.length; i++) {
            if (cfg[i].ID == id) return cfg[i];
          }

          return null;
        }

      };

      _export("default", BaseData);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=BaseData.js.map