System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./BaseData", "./global", "../utils/UtilsMath", "./DataManager"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, BaseData, global, MathRandom, DataManager, levelMgr, _crd, ccclass, property, CONFIGS;

  function _reportPossibleCrUseOfBaseData(extras) {
    _reporterNs.report("BaseData", "./BaseData", _context.meta, extras);
  }

  function _reportPossibleCrUseOfglobal(extras) {
    _reporterNs.report("global", "./global", _context.meta, extras);
  }

  function _reportPossibleCrUseOfMathRandom(extras) {
    _reporterNs.report("MathRandom", "../utils/UtilsMath", _context.meta, extras);
  }

  function _reportPossibleCrUseOfDataManager(extras) {
    _reporterNs.report("DataManager", "./DataManager", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
    }, function (_BaseData) {
      BaseData = _BaseData.default;
    }, function (_global) {
      global = _global.default;
    }, function (_utilsUtilsMath) {
      MathRandom = _utilsUtilsMath.MathRandom;
    }, function (_DataManager) {
      DataManager = _DataManager.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9ef54T7iuBEk67+/wSZV9bV", "levelMgr", undefined);

      ({
        ccclass,
        property
      } = _decorator);
      CONFIGS = {
        cacheName: "levelInfo"
      };
      //关卡数据管理
      levelMgr = class levelMgr extends (_crd && BaseData === void 0 ? (_reportPossibleCrUseOfBaseData({
        error: Error()
      }), BaseData) : BaseData) {
        //字段可以直接读,改动最好通过接口

        /**后台数据 */

        /**游戏状态 */
        constructor() {
          super(CONFIGS.cacheName);
        }

        init() {
          let info = this.getCache();

          if (info) {
            this.dictCache = info;
          } else {
            this.dataInit();
          }
        }
        /**数据初始化 */


        dataInit() {
          this.dictCache = {
            Checkpoint: 1
          };
          this.updateCache();
        }
        /**
         * 获取当前关卡
         */


        get checkPoint() {
          return this.dictCache.Checkpoint;
        }
        /**
         * 当前关卡+1
         */


        setCheckpoint() {
          this.dictCache.Checkpoint++;
          this.updateCache();
        }
        /**获取关卡数据
         * @param ID 如果传进关卡ID，则指定加载某一关
         */


        getCheckJson(ID) {
          var num = 0;

          if (ID) {
            num = ID;
          } else {
            num = this.dictCache.Checkpoint; //超过关卡上限，随机一关出来

            if (num > (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).levelCount) {
              num = (_crd && MathRandom === void 0 ? (_reportPossibleCrUseOfMathRandom({
                error: Error()
              }), MathRandom) : MathRandom).getInstance().RandomNumBoth(1, (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                error: Error()
              }), global) : global).levelCount);
            }
          }

          const lv = "level" + num;
          return (_crd && DataManager === void 0 ? (_reportPossibleCrUseOfDataManager({
            error: Error()
          }), DataManager) : DataManager).getTable(lv);
        }

      };

      _export("default", levelMgr);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=levelMgr.js.map