System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../../../config/GDef", "../../notifications"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, GDef, Notifications, oppoAdMange, _crd, OPPO;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../../../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../../notifications", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_notifications) {
      Notifications = _notifications.Notifications;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "18ff6FLcTRGLqEAGZeJL9rX", "oppoAdMange", undefined);

      oppoAdMange = class oppoAdMange {
        constructor() {
          _defineProperty(this, "rewardVideoAd", void 0);

          _defineProperty(this, "bannerAd", void 0);

          _defineProperty(this, "nativeAd", void 0);

          _defineProperty(this, "insertAd", void 0);

          _defineProperty(this, "_rewardVideoAdUnitId", '304847');

          _defineProperty(this, "_banneradUnitId", '304845');

          _defineProperty(this, "nativeadUnitId", '');

          _defineProperty(this, "insertAdUnitId", '');
        }

        set bannerAdUnitId(adUnitId) {
          this._banneradUnitId = adUnitId;
        }

        set rewardedVideoAdUnitId(adUnitId) {
          this._rewardVideoAdUnitId = adUnitId;
        } //获取系统信息的同步版本


        get systemInfo() {
          return qg.getSystemInfoSync();
        }
        /**登陆接口 */


        login() {
          qg.login({
            success: res => {
              // 可全局储存 token，方便其他能力获取，注意 token 过期时间
              console.log(`登录成功: ${JSON.stringify(res.data)}`);
            },
            fail: res => {
              console.log(`登录失败: ${JSON.stringify(res)}`);
            }
          });
        }
        /**获取授权信息  */


        getProfile(_token) {
          return new Promise((resolve, reject) => {
            qg.getProfile({
              token: _token,
              success: function (data) {
                resolve(data);
              },
              fail: function (data, code) {
                reject(data);
              }
            });
          });
        }
        /**  退出游戏，同步方法*/


        exitApplication() {
          qg.exitApplication();
        }
        /**使手机发生较短时间的振动（20 ms） */


        vibrateShort() {
          qg.vibrateShort({
            success: function (res) {},
            fail: function (res) {},
            complete: function (res) {}
          });
        }
        /**使手机发生较长时间的振动（400 ms) */


        vibrateLong() {
          qg.vibrateLong({
            success: function (res) {},
            fail: function (res) {},
            complete: function (res) {}
          });
        } //=============================广告

        /**展示激励视频 */


        showRewardVideoAd(cb, fail) {
          console.log("展示激励视频"); //    if(this.systemInfo.minPlatformVersion<1051)return
          // return new Promise<void>((resolve, reject) => {

          this.rewardVideoAd = qg.createRewardedVideoAd({
            adUnitId: this._rewardVideoAdUnitId
          });
          console.log('加载广告');
          this.rewardVideoAd.load().then(() => {
            console.log('promise 回调：加载成功');
            console.log('展示广告'); // 调用 show 方法请求展示 banner，成功的时候回调 onShow，出错的时候回调 onError

            this.rewardVideoAd.show().then(() => {
              console.log('promise 回调：展示成功');
            }).catch(err => {
              console.log(`promise 回调：展示失败 ${JSON.stringify(err)}`);

              if (fail) {
                fail();
                (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                  error: Error()
                }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败:广告展示失败");
                return;
              }
            });
          }).catch(err => {
            console.log(`promise 回调：加载失败 ${JSON.stringify(err)}`);

            if (fail) {
              fail();
              (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                error: Error()
              }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                error: Error()
              }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败:广告加载失败");
              return;
            }
          });
          this.rewardVideoAd.onClose(res => {
            if (res.isEnded) {
              cc.log('激励视频广告完成，发放奖励');
              cb();
              this.rewardVideoAd.offClose(); // resolve();
            } else {
              cc.log('激励视频广告取消关闭，不发放奖励'); // reject();

              this.rewardVideoAd.offClose();

              if (fail) {
                fail();
                (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                  error: Error()
                }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败");
              }
            }
          }); // })
        }
        /**展示Banner广告 */


        showBannerAd() {
          console.log("展示banner视频");
          if (this.systemInfo.minPlatformVersion < 1051) return;

          if (this.bannerAd) {
            return;
          }

          this.bannerAd = qg.createBannerAd({
            adUnitId: this._banneradUnitId
          });
          console.log("创建成功");
          this.bannerAd.onLoad(() => {
            cc.log('banner 广告加载成功');
          });
          this.bannerAd.show(() => {
            cc.log('banner 广告显示');
          });
          this.bannerAd.onError(function (err) {
            cc.error("banner 广告出错");
            cc.error(JSON.stringify(err));
            this.bannerAd.destroy();
            this.bannerAd = null;
          });
        }
        /**隐藏Banner广告 */


        hideBannerAd() {
          if (this.bannerAd) {
            this.bannerAd.hide();
            this.bannerAd.destroy();
            this.bannerAd = null;
          }
        }
        /**展示原生插屏广告 */


        showInterstitialAd() {}
        /**原生插屏 */


        creatorInterstitialAd() {}
        /**创建原生广告 */


        createNativeAd() {
          if (this.systemInfo.platformVersionCode < 1051) return;
          this.nativeAd = qg.createNativeAd({
            posId: this.nativeadUnitId
          });
          console.log("原生广告原生广告", this.nativeAd);
          this.nativeAd.onLoad(function (res) {
            if (res && res.adList) {
              console.log("原生广告", res);
              this.clickNativeAd(res.adList);
            }
          });
          this.nativeAd.onError(function (res) {
            console.log('原生广告加载失败', res);
          });
          let adLoad = this.nativeAd.load();
          adLoad && adLoad.then(() => {
            console.log("原生广告加载成功");
          }).catch(err => {
            console.log('原生广告加载失败', JSON.stringify(err));
          });
        }
        /**上报原生点击 */


        clickNativeAd(adId) {
          this.nativeAd.reportAdClick({
            adId: adId
          });
        } // 检查登录信息 5分钟后token 失效


        getSetting(cbOK, cbFail = null) {}
        /**判断是否已经创建桌面图标 */


        hasShortcutInstalled() {
          this.login();
          qg.hasShortcutInstalled({
            success: function (res) {
              // 判断图标未存在时，创建图标
              if (res == false) {
                qg.installShortcut({
                  success: function () {// 执行用户创建图标奖励
                  },
                  fail: function (err) {},
                  complete: function () {}
                });
              }
            },
            fail: function (err) {},
            complete: function () {}
          });
        }
        /**设置游戏加载进度页面（该功能必须接入，否则会因为未接入，导致游戏加载页进度条缺失而被测试打回） */


        setLoadingProgress() {
          qg.setLoadingProgress({
            progress: 50
          });
        }
        /**隐藏游戏加载进度页面 */


        loadingComplete() {
          qg.loadingComplete({
            complete: function (res) {}
          });
        }

      };

      _defineProperty(oppoAdMange, "_instance", new oppoAdMange());

      _export("OPPO", OPPO = oppoAdMange._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=oppoAdMange.js.map