System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../config/GD", "../config/GDef", "./BaseView"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, AudioClip, AudioSource, resources, GD, GDef, BaseView, _dec, _class, _temp, _crd, ccclass, property, AudioMgr;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfGD(extras) {
    _reporterNs.report("GD", "../config/GD", _context.meta, extras);
  }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfBaseView(extras) {
    _reporterNs.report("BaseView", "./BaseView", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      AudioClip = _cc.AudioClip;
      AudioSource = _cc.AudioSource;
      resources = _cc.resources;
    }, function (_configGD) {
      GD = _configGD.default;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_BaseView) {
      BaseView = _BaseView.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "b66f2P8mf5HlLkl72/TcIUq", "AudioMgr", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("AudioMgr", AudioMgr = (_dec = ccclass('AudioMgr'), _dec(_class = (_temp = class AudioMgr extends (_crd && BaseView === void 0 ? (_reportPossibleCrUseOfBaseView({
        error: Error()
      }), BaseView) : BaseView) {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "audioMgr", null);

          _defineProperty(this, "audio", true);

          _defineProperty(this, "_filePath", 'audio');

          _defineProperty(this, "soundResouces", []);
        }

        //音频剪辑
        start() {
          this.audioMgr = this.node.getComponent(AudioSource);
          this.on((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.playEffect, this.playEffect); //播放音效

          this.on((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.playBgm, this.playMusic);
          this.on((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.voiceSet, this.btn_audioSeting_cb);
          let Audio = (_crd && GD === void 0 ? (_reportPossibleCrUseOfGD({
            error: Error()
          }), GD) : GD).playerMgr.Voice;

          if (!Audio) {
            this.audio = false;
          } else {
            this.audio = true;
          }

          this.loadAudio();
        }
        /**
        * 加载音频文件
        */


        loadAudio() {
          resources.loadDir(this._filePath, AudioClip, (error, resources) => {
            if (error) {
              console.log('load sound error: ', error);
              return;
            }

            for (let index = 0; index < resources.length; index++) {
              let soundResouce = resources[index];
              this.soundResouces[soundResouce._name] = soundResouce;
            }

            this.scheduleOnce(() => {
              this.playMusic(true);
            }, 1);
            console.log('load sound resources success');
          });
        }
        /**
          * 声音设置
          */


        btn_audioSeting_cb(bool) {
          this.audio = bool; // GD.playerMgr.Voice = this.audio;

          this.pause(); //播放或暂停声音
          // this.playEffect("btn");
        }
        /**
        * @description 暂停声音
        */


        pause() {
          if (!this.audio) {
            this.audioMgr.pause();
          } else {
            this.audioMgr.play();
          }
        }
        /**
           * @description 播放音效
           * @param {string} fileName
           */


        playEffect(fileName) {
          let audioClip = this.isCanPlayAudio(fileName);

          if (audioClip) {
            this.audioMgr.playOneShot(audioClip);
          }
        }
        /**
           * @description 播放音乐（默认循环）
           * @param {string} fileName
           */


        playMusic(bool) {
          let fileName = "bgm";
          let audioClicp = this.isCanPlayAudio(fileName);

          if (audioClicp) {
            this.audioMgr.clip = audioClicp;

            if (bool) {
              this.audioMgr.play();
            } else {
              this.audioMgr.stop();
            }
          }
        }
        /**
        * @description 播放声音
        * @param fileName
        */


        isCanPlayAudio(fileName) {
          if (!this.audio) {
            console.log("处于静音");
            return null;
          }

          let file = this.soundResouces[fileName];

          if (!file) {
            console.log('sound: fieName is error, please check it');
            return null;
          }

          return file;
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }


      }, _temp)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=AudioMgr.js.map