System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../easyFramework/notifications", "../config/GDef", "../config/global", "../easyFramework/channel/toutiao/toutiao", "../easyFramework/channel/wechat/wechat", "../config/GD"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, ButtonComponent, instantiate, Notifications, GDef, global, CHANNEL, Toutiao, Wechat, GD, _dec, _class, _temp, _crd, ccclass, property, BaseView;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../easyFramework/notifications", _context.meta, extras);
  }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfglobal(extras) {
    _reporterNs.report("global", "../config/global", _context.meta, extras);
  }

  function _reportPossibleCrUseOfCHANNEL(extras) {
    _reporterNs.report("CHANNEL", "../config/global", _context.meta, extras);
  }

  function _reportPossibleCrUseOfToutiao(extras) {
    _reporterNs.report("Toutiao", "../easyFramework/channel/toutiao/toutiao", _context.meta, extras);
  }

  function _reportPossibleCrUseOfWechat(extras) {
    _reporterNs.report("Wechat", "../easyFramework/channel/wechat/wechat", _context.meta, extras);
  }

  function _reportPossibleCrUseOfGD(extras) {
    _reporterNs.report("GD", "../config/GD", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      ButtonComponent = _cc.ButtonComponent;
      instantiate = _cc.instantiate;
    }, function (_easyFrameworkNotifications) {
      Notifications = _easyFrameworkNotifications.Notifications;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_configGlobal) {
      global = _configGlobal.default;
      CHANNEL = _configGlobal.CHANNEL;
    }, function (_easyFrameworkChannelToutiaoToutiao) {
      Toutiao = _easyFrameworkChannelToutiaoToutiao.Toutiao;
    }, function (_easyFrameworkChannelWechatWechat) {
      Wechat = _easyFrameworkChannelWechatWechat.Wechat;
    }, function (_configGD) {
      GD = _configGD.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "70b05EvIUtGQauSWdoM7yG1", "BaseView", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("default", BaseView = (_dec = ccclass("BaseView"), _dec(_class = (_temp = class BaseView extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_clickEnable", true);

          _defineProperty(this, "_onEvent", false);
        }

        //判断是否有事件监听

        /**
         * 添加事件
         * @param {string} eKey     识别key
         * @param {object} eCall    回调函数
         * @param {object} self     识别对象
         */
        on(eKey, eCall, self) {
          (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).on(eKey, eCall, self ? self : this);
          this._onEvent = true;
        }
        /**
         * 通知事件
         * @param {string} eKey     识别key
         * @param {object} data     传值
         * @param {object} data2     传值
         */


        emit(eKey, ...parameters) {
          let a = (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).emit(eKey, ...parameters);

          if (a) {
            return a;
          }
        }
        /**
        * 注销某个事件
        * @param {string} eKey 识别key
        * @param {object} self 识别对象 
        */


        off(eKey, self) {
          (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).off(eKey, self ? self : this);
        }
        /**
         * 绑定按钮点击事件,永久监听
         * @param node 挂载了button组件的节点
         * @param callback 回调
         * @param opname 操作内容
         */


        bindButton(node, callback, ...parameters) {
          let btnComp = node.getComponent(ButtonComponent);

          if (!btnComp) {
            btnComp = node.addComponent(ButtonComponent);
            btnComp.transition = ButtonComponent.Transition.SCALE;
          }

          btnComp.zoomScale = 0.9;

          let btnCb = event => {
            this.emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
              error: Error()
            }), GDef) : GDef).wdEvent.playEffect, "btn");
            if (!this._clickEnable) return;
            this._clickEnable = false;
            this.scheduleOnce(() => {
              this._clickEnable = true;
            }, 0.3);
            callback.call(this, ...parameters);
            TyqSdk.outMain();
          };

          node.on("click", btnCb, this);
        }
        /**
        * 绑定按钮点击事件(只监听一次)
        * @param node 挂载了button组件的节点
        * @param callback 回调
        * @param opname 操作内容
        */


        bindButtonOce(node, callback, opname) {
          let btnComp = node.getComponent(ButtonComponent);

          if (!btnComp) {
            btnComp = node.addComponent(ButtonComponent);
            btnComp.transition = ButtonComponent.Transition.SCALE;
          }

          btnComp.zoomScale = 0.9;

          let btnCb = event => {
            if (!this._clickEnable) return;
            this._clickEnable = false;
            this.scheduleOnce(() => {
              this._clickEnable = true;
            }, 0.3);
            callback.call(this, event);
          };

          node.once("click", btnCb, this);
        }

        onDestroy() {
          if (this._onEvent) {
            (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
              error: Error()
            }), Notifications) : Notifications).offTarget(this);
          }
        }
        /**
         * 加载预制体，UI都用这个方法
         * @param cPrefab 要生成的预制体
         * @param cNode 父节点
         * @param next 返回预制体的主脚本
         */


        showUI(cPrefab, cNode, next) {
          let node = instantiate(cPrefab);
          node.parent = cNode;
          next && next(node.getComponent(node.name) ? node.getComponent(node.name) : node);
        }
        /**震动 */


        shock() {
          const bool = (_crd && GD === void 0 ? (_reportPossibleCrUseOfGD({
            error: Error()
          }), GD) : GD).playerMgr.Shock;
          if (!bool) return;

          if ((_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
            error: Error()
          }), global) : global).channel == (_crd && CHANNEL === void 0 ? (_reportPossibleCrUseOfCHANNEL({
            error: Error()
          }), CHANNEL) : CHANNEL).TT) {
            (_crd && Toutiao === void 0 ? (_reportPossibleCrUseOfToutiao({
              error: Error()
            }), Toutiao) : Toutiao).vibrateShort();
          } else if ((_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
            error: Error()
          }), global) : global).channel == (_crd && CHANNEL === void 0 ? (_reportPossibleCrUseOfCHANNEL({
            error: Error()
          }), CHANNEL) : CHANNEL).WECHAT) {
            (_crd && Wechat === void 0 ? (_reportPossibleCrUseOfWechat({
              error: Error()
            }), Wechat) : Wechat).vibrateShort();
          }
        }

      }, _temp)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=BaseView.js.map