System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _crd, notifications, Notifications;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "99fb07iraZAC4NAQTebcrBb", "notifications", undefined);

      _export("notifications", notifications = /*#__PURE__*/function () {
        function notifications() {
          _defineProperty(this, "_eventMap", {});
        }

        var _proto = notifications.prototype;

        /**
         * @description 事件注册
         * @param {string} type
         * @param callback
         * @param target
         */
        _proto.on = function on(type, callback, target) {
          if (!callback || !type) {
            console.error(type + "\u4E8B\u4EF6\u6CE8\u518C\u5931\u8D25...");
            return null;
          }

          if (!this._eventMap[type]) {
            this._eventMap[type] = [];
          } // 以type为key


          this._eventMap[type].push({
            callback: callback,
            target: target
          }); // console.log('============================>注册事件', type);

        }
        /**
         * @description 注册事件目标的特定事件类型回调，回调会在第一时间被触发后删除自身。
         * @param {string} type
         * @param {Function} callback
         * @param {Object} target
         */
        ;

        _proto.once = function once(type, callback, target) {
          var _this = this;

          this.on(type, function (parameters) {
            _this.off(type, target);

            callback.call(target, parameters);
          }, target);
        }
        /**
         * @description 派发事件
         * @param {string} type
         * @param parameters
         */
        ;

        _proto.emit = function emit(type) {
          var eventList = this._eventMap[type];

          if (!eventList) {
            // console.error(`派发${type}失败...`);
            return;
          }

          for (var _len = arguments.length, parameters = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            parameters[_key - 1] = arguments[_key];
          }

          for (var key in eventList) {
            if (eventList.hasOwnProperty(key)) {
              var element = eventList[key];

              if (element && element.target) {
                var _element$callback;

                var a = (_element$callback = element.callback).call.apply(_element$callback, [element.target].concat(parameters));

                if (a) {
                  return a;
                } // console.log('============================>派发事件：' + type + ',parameters:' + parameters);

              }
            }
          }
        }
        /**
         * @description 注销事件
         * @param type
         * @param target
         */
        ;

        _proto.off = function off(type, target) {
          var eventList = this._eventMap[type];
          if (!eventList) return;

          for (var key in eventList) {
            if (eventList.hasOwnProperty(key)) {
              var element = eventList[key];

              if (element && element.target === target) {
                eventList[key] = null;
                eventList.splice(Number(key), 1); // console.log('============================>注销事件：' + type);
              }
            }
          }

          if (eventList.length === 0) {
            delete this._eventMap[type];
          }
        }
        /**
         * @description 注销该对象的所有事件，（不推荐使用，在事件多的情况下O(n^2)是很消耗计算的）
         * @param target
         */
        ;

        _proto.offTarget = function offTarget(target) {
          for (var type in this._eventMap) {
            if (this._eventMap.hasOwnProperty(type)) {
              var eventList = this._eventMap[type];

              for (var index = 0; index < eventList.length; index++) {
                var obj = eventList[index]; // 找到对象

                if (obj && obj.target && obj.target === target) {
                  eventList.splice(index, 1);
                }
              }
            }

            if (this._eventMap.hasOwnProperty(type) && this._eventMap[type].length === 0) {
              delete this._eventMap[type];
            }
          }
        };

        return notifications;
      }());

      _defineProperty(notifications, "_instance", new notifications());

      _export("Notifications", Notifications = notifications._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=notifications.js.map