System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../config/GD", "../config/GDef", "./BaseView"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, AudioClip, AudioSource, resources, GD, GDef, BaseView, _dec, _class, _temp, _crd, ccclass, property, AudioMgr;

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfGD(extras) {
    _reporterNs.report("GD", "../config/GD", _context.meta, extras);
  }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfBaseView(extras) {
    _reporterNs.report("BaseView", "./BaseView", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      AudioClip = _cc.AudioClip;
      AudioSource = _cc.AudioSource;
      resources = _cc.resources;
    }, function (_configGD) {
      GD = _configGD.default;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_BaseView) {
      BaseView = _BaseView.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "b66f2P8mf5HlLkl72/TcIUq", "AudioMgr", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("AudioMgr", AudioMgr = (_dec = ccclass('AudioMgr'), _dec(_class = (_temp = /*#__PURE__*/function (_ref) {
        _inheritsLoose(AudioMgr, _ref);

        function AudioMgr() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _ref.call.apply(_ref, [this].concat(args)) || this;

          _defineProperty(_assertThisInitialized(_this), "audioMgr", null);

          _defineProperty(_assertThisInitialized(_this), "audio", true);

          _defineProperty(_assertThisInitialized(_this), "_filePath", 'audio');

          _defineProperty(_assertThisInitialized(_this), "soundResouces", []);

          return _this;
        }

        var _proto = AudioMgr.prototype;

        //音频剪辑
        _proto.start = function start() {
          this.audioMgr = this.node.getComponent(AudioSource);
          this.on((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.playEffect, this.playEffect); //播放音效

          this.on((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.playBgm, this.playMusic);
          this.on((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.voiceSet, this.btn_audioSeting_cb);
          var Audio = (_crd && GD === void 0 ? (_reportPossibleCrUseOfGD({
            error: Error()
          }), GD) : GD).playerMgr.Voice;

          if (!Audio) {
            this.audio = false;
          } else {
            this.audio = true;
          }

          this.loadAudio();
        }
        /**
        * 加载音频文件
        */
        ;

        _proto.loadAudio = function loadAudio() {
          var _this2 = this;

          resources.loadDir(this._filePath, AudioClip, function (error, resources) {
            if (error) {
              console.log('load sound error: ', error);
              return;
            }

            for (var index = 0; index < resources.length; index++) {
              var soundResouce = resources[index];
              _this2.soundResouces[soundResouce._name] = soundResouce;
            }

            _this2.scheduleOnce(function () {
              _this2.playMusic(true);
            }, 1);

            console.log('load sound resources success');
          });
        }
        /**
          * 声音设置
          */
        ;

        _proto.btn_audioSeting_cb = function btn_audioSeting_cb(bool) {
          this.audio = bool; // GD.playerMgr.Voice = this.audio;

          this.pause(); //播放或暂停声音
          // this.playEffect("btn");
        }
        /**
        * @description 暂停声音
        */
        ;

        _proto.pause = function pause() {
          if (!this.audio) {
            this.audioMgr.pause();
          } else {
            this.audioMgr.play();
          }
        }
        /**
           * @description 播放音效
           * @param {string} fileName
           */
        ;

        _proto.playEffect = function playEffect(fileName) {
          var audioClip = this.isCanPlayAudio(fileName);

          if (audioClip) {
            this.audioMgr.playOneShot(audioClip);
          }
        }
        /**
           * @description 播放音乐（默认循环）
           * @param {string} fileName
           */
        ;

        _proto.playMusic = function playMusic(bool) {
          var fileName = "bgm";
          var audioClicp = this.isCanPlayAudio(fileName);

          if (audioClicp) {
            this.audioMgr.clip = audioClicp;

            if (bool) {
              this.audioMgr.play();
            } else {
              this.audioMgr.stop();
            }
          }
        }
        /**
        * @description 播放声音
        * @param fileName
        */
        ;

        _proto.isCanPlayAudio = function isCanPlayAudio(fileName) {
          if (!this.audio) {
            console.log("处于静音");
            return null;
          }

          var file = this.soundResouces[fileName];

          if (!file) {
            console.log('sound: fieName is error, please check it');
            return null;
          }

          return file;
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }
        ;

        return AudioMgr;
      }(_crd && BaseView === void 0 ? (_reportPossibleCrUseOfBaseView({
        error: Error()
      }), BaseView) : BaseView), _temp)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=AudioMgr.js.map